# $Id: gps-series60.py 114 2005-04-25 12:24:39Z jcea $

from math import sin,asin,cos,acos,tan,atan2,sqrt,pi

# WGS-84
EquatorialRadius=6378137
eccSquared=eccentricitySquared=0.00669438

deg2rad=2*pi/360

letraUTM="ZZZZZZZZZZCCCCCCCCDDDDDDDDEEEEEEEEFFFFFFFFGGGGGGGG" \
         "HHHHHHHHJJJJJJJJKKKKKKKKLLLLLLLLMMMMMMMMNNNNNNNN" \
         "PPPPPPPPQQQQQQQQRRRRRRRRSSSSSSSSTTTTTTTTUUUUUUUU" \
         "VVVVVVVVWWWWWWWWXXXXXXXXXXXXZZZZZZ"

def latlong2utm(lat,long) :
  lat,lat2=float(lat[:-1]),lat[-1]
  long,long2=float(long[:-1]),long[-1]
  lat=lat//100.0+(lat%100.0)/60.0
  long=long//100.0+(long%100.0)/60.0
  if lat2!="N" : lat=-lat
  if long2!="E" : long=-long

  latRad=lat*deg2rad
  longRad=long*deg2rad

  zona=int((long+180)/6)+1

  if (lat>=56.0) and (lat<64.0) and (long>=3.0) and (long<12.0) :
    zona=32

  if (lat>=72.0) and (lat<84.0) :
    if (long>=0.0) and (long<9.0) :
      zona=32
    elif (long>=9.0) and (long<21.0) :
      zona=33
    elif (long>=21.0) and (long<33.0) :
      zona=35
    elif (long>=33.0) and (long<42.0) :
      zona=37

  longOrigen=(zona-1)*6-180+3
  longOrigenRad=longOrigen*deg2rad

  eccPrimeSquared = (eccSquared)/(1-eccSquared)

  N=EquatorialRadius/sqrt(1-eccSquared*sin(latRad)*sin(latRad))
  T=tan(latRad)*tan(latRad)
  C=eccPrimeSquared*cos(latRad)*cos(latRad)
  A=cos(latRad)*(longRad-longOrigenRad)
  M=EquatorialRadius*((1-eccSquared/4-3*eccSquared*eccSquared/64-5*eccSquared*eccSquared*eccSquared/256)*latRad
    -(3*eccSquared/8+3*eccSquared*eccSquared/32+45*eccSquared*eccSquared*eccSquared/1024)*sin(2*latRad)
    +(15*eccSquared*eccSquared/256+45*eccSquared*eccSquared*eccSquared/1024)*sin(4*latRad)
    -(35*eccSquared*eccSquared*eccSquared/3072)*sin(6*latRad))

  UTMEasting=0.9996*N*(A+(1-T+C)*A*A*A/6 \
             +(5-18*T+T*T+72*C-58*eccPrimeSquared)*A*A*A*A*A/120) \
             +500000.0

  UTMNorthing=0.9996*(M+N*tan(latRad)*(A*A/2+(5-T+9*C+4*C*C)*A*A*A*A/24 \
              + (61-58*T+T*T+600*C-330*eccPrimeSquared)*A*A*A*A*A*A/720))

  if lat<0.0 :
    UTMNorthing+=10000000.0

  return zona,letraUTM[int(90+lat)],UTMEasting,UTMNorthing




waypoints=[(u"pepe","0.0N","300.0W"), 
           (u"Madrid","4026.943N","341.280W"),
           (u"Madrid, just a walk","4025.116N","341.557W"),
           (u"Olivar de la Hinojosa","4027.661N","336.186W"),
           (u"Madrid, when you are there","4024.9N","341.553W"),
           (u"Warner Bros","4013.813N","335.671W"),
           (u"La Torre de los Lodones","4034.388N","355.947W")]

waypoints2=[]
for nombre,lat,long in waypoints :
  lat2,lat3=float(lat[:-1]),lat[-1]
  long2,long3=float(long[:-1]),long[-1]
  lat2=lat2//100.0+(lat2%100.0)/60.0
  long2=long2//100.0+(long2%100.0)/60.0
  if lat3!="N" : lat2=-lat2
  if long3!="E" : long2=-long2

  latRad=lat2*deg2rad
  longRad=long2*deg2rad

  waypoints2.append((nombre,lat,long,latRad,longRad))

waypoints=waypoints2




import time
import e32
import appuifw

# TS,valid,lat,long,altura,geoide,dop,sats,estado,Ultimo TS de FIX valido
fix=["Iniciando...","0","0.0N","0.0W","0.0","0.0","1.0","0","$Id: gps-series60.py 114 2005-04-25 12:24:39Z jcea $","?"]

lock=e32.Ao_lock()
flag_salir=False

old_title=appuifw.app.title
appuifw.app.title=u"PyTrek"

def avisa_salida() :
  global flag_salir
  flag_salir=True
  lock.signal()

def muestras_60segundos() :
  global out
  out="$PNMRX103,ALL,60*2C\r\n"

def muestras_15segundos() :
  global out
  out="$PNMRX103,ALL,15*2E\r\n"

def muestras_5segundos() :
 global out
 out="$PNMRX103,ALL,5*1F\r\n"

def muestras_1segundos() :
  global out
  out="$PNMRX103,ALL,1*1B\r\n"


fichero="D:\\GPS"
destino="E:\\Others\\"
grabando=False
pasar_a_tarjeta=False

def parar_grabacion() :
  global grabando,menu_primario
  grabando=False
  menu_primario=menu(m1,primera_entrada=(u"GRABAR",iniciar_grabacion))

def iniciar_grabacion() :
  global grabando,menu_primario
  grabando=True
  menu_primario=menu(m1,primera_entrada=(u"PARAR GRABACION",parar_grabacion))

appuifw.app.exit_key_handler = avisa_salida

def pasar_tarjeta() :
  global lock,pasar_a_tarjeta
  pasar_a_tarjeta=True
  lock.signal()
 
def menu(m,primera_entrada=None,ultima_entrada=None) :
  m2=m
  if ultima_entrada :
    m2=m2+[ultima_entrada]
  if primera_entrada :
    m2=[primera_entrada]+m2

  appuifw.app.menu=m2

  return m2

m1=[(u"60 segundos",muestras_60segundos),
    (u"15 segundos",muestras_15segundos),
    (u"5 segundos",muestras_5segundos),
    (u"1 segundos",muestras_1segundos),
    (u"Pasar a la tarjeta",pasar_tarjeta)]

def waypoint_guardar_actual() :
  global waypoints,fix

  lat,long=fix[2],fix[3]
  lat2,lat3=float(lat[:-1]),lat[-1]
  long2,long3=float(long[:-1]),long[-1]
  lat2=lat2//100.0+(lat2%100.0)/60.0
  long2=long2//100.0+(long2%100.0)/60.0
  if lat3!="N" : lat2=-lat2
  if long3!="E" : long2=-long2

  latRad=lat2*deg2rad
  longRad=long2*deg2rad

  nombre=appuifw.query(u"Nombre del WayPoint","text")
  if nombre!=None :
    waypoints.append((nombre,lat,long,latRad,longRad))

def waypoint_guardar_nuevo() :
  global waypoints,fix

  lat,long=fix[2],fix[3]
  a=appuifw.Form([(u"Nombre del WayPoint","text",u""),
                  (u"Latitud","text",unicode(lat)),
                  (u"Longitud","text",unicode(long)),],
                  appuifw.FFormEditModeOnly)
  a.execute()
  nombre,lat,long=a[0][2],a[1][2].encode(),a[2][2].encode()
  if not nombre : return

  lat2,lat3=float(lat[:-1]),lat[-1]
  long2,long3=float(long[:-1]),long[-1]
  lat2=lat2//100.0+(lat2%100.0)/60.0
  long2=long2//100.0+(long2%100.0)/60.0
  if lat3!="N" : lat2=-lat2
  if long3!="E" : long2=-long2

  latRad=lat2*deg2rad
  longRad=long2*deg2rad

  waypoints.append((nombre,lat,long,latRad,longRad))


m2=[(u"Guardar actual",waypoint_guardar_actual),
    (u"Definir nuevo",waypoint_guardar_nuevo),]

menu_primario=menu(m1,primera_entrada=(u"GRABAR",iniciar_grabacion))

out=""

import thread
def receptor() :
  from operator import xor
  global grabando,fichero,lock,out,flag_salir,fix

  while not flag_salir :
    try :
      import socket
      s=socket.socket(socket.AF_BT,socket.SOCK_STREAM)
      target=("00:08:1b:c0:d5:17",1)
      s.connect(target)
      fix[8]="$Id: gps-series60.py 114 2005-04-25 12:24:39Z jcea $"

      while not flag_salir :
        ch=out
        if ch :
          out=""
          s.send(ch)
        ch=""
        while ch!="$" :
          ch=s.read(1)
        txt=""
        while ch!="\r" :
          txt+=ch
          ch=s.read(1)
        if txt[:6]=="$GPGGA" :
          if txt[-3]=="*" :
            a=reduce(xor,map(ord,txt[1:-3]))
            if a==int(txt[-2:],16) :
              dummy1,hora,lat,lat2,long,long2,valid,sats,dop,alt,dummy4,geoide,dummy6,dummy7,dummy8=txt.split(",")
              fix[0]=hora
              fix[1]=valid
              if valid=="1" :
                fix[9]=hora
              fix[2]=lat+lat2
              fix[3]=long+long2
              fix[4]=alt
              fix[5]=geoide
              fix[6]=dop
              fix[7]=sats
              lock.signal()
              if grabando :
                f=open(fichero,"a")
                print >>f,txt
                f.close()
      try :
        s.close()
      except :
        pass

    except :
      fix[8]=time.ctime()[4:]+": PROBLEMAS GPS"
      lock.signal()
      e32.ao_sleep(5)


thread.start_new_thread(receptor,())

# Es importante saltarnos los caracteres del dia en "time.ctime()", porque
# si contienen tildes (por ejemplo, "miercoles" o "sabado") el programa falla
# sin ningun tipo de indicacion o pista.
print "%s: Iniciando programa $Id: gps-series60.py 114 2005-04-25 12:24:39Z jcea $" %time.ctime()[4:]

def cambia_tab(tab) :
  global tab_visible,tab_visible_old,lock

  tab_visible_old=tab_visible
  tab_visible=tab
  lock.signal()

appuifw.app.set_tabs([u"Lat&Long",u"UTM",u"WayPoints",u"Saver"],cambia_tab)
tab_visible=0
tab_visible_old=-1

text_principal=appuifw.Text()
appuifw.app.body=text_principal
text_principal.focus=False
ts="Iniciando..."

lock.signal()

while 1 :
  lock.wait()

  if tab_visible!=tab_visible_old :
    if tab_visible==2 : # WayPoints
      menu(m2)
    elif tab_visible_old==2 : # WayPoints
      menu(menu_primario) 

  last_TS=ts
  ts=fix[0]

  if flag_salir : break
  if pasar_a_tarjeta :
    pasar_a_tarjeta=False
    text_principal.set(u"\n\n\n\nCOPIANDO Y BORRANDO ORIGINAL...")
    import os
    d=destino+"GPS-%s" %time.strftime("%Y%m%d-%H%M%S")
    e32.file_copy(d,fichero)
    os.unlink(fichero)

  if tab_visible==0 : # LAT & LONG
    txt=u"%s (%s)\n%s, %s\nAlt: %s (%s) - DOP: %s\nSats: %s %s - %s\n\n\
%s" %(ts,last_TS,fix[2],fix[3],fix[4],fix[5],fix[6],fix[7],fix[1],fix[9],fix[8])
    text_principal.set(txt)
  elif tab_visible==1 : # UTM
    lat,long=fix[2],fix[3]
    a,b,c,d=latlong2utm(lat,long)
    txt=u"%s (%s)\n%s, %s\n\n%s   %02d%s %06d %07.d\n\n%s" %(ts,last_TS,lat,long,fix[1],a,b,int(round(c)),int(round(d)),fix[8])
    text_principal.set(txt)
  elif tab_visible==2 : # WayPoints
    if tab_visible_old!=tab_visible :
      lat,long=fix[2],fix[3]
      lat,lat2=float(lat[:-1]),lat[-1]
      long,long2=float(long[:-1]),long[-1]
      lat=lat//100.0+(lat%100.0)/60.0
      long=long//100.0+(long%100.0)/60.0
      if lat2!="N" : lat=-lat
      if long2!="E" : long=-long

      latRad=lat*deg2rad
      longRad=long*deg2rad

      w=[]
      for nombre,lat_txt,long_txt,lat,long in waypoints :
        a=sin((lat-latRad)/2)
        a*=a
        b=sin((long-longRad)/2)
        b*=b
        d=2*asin(sqrt(a+cos(lat)*cos(latRad)*b))
        tc=0
        if d>0.0 :
          tc=acos((sin(lat)-sin(latRad)*cos(d))/(sin(d)*cos(latRad)))
          if sin(long-longRad)<0 :
            tc=2*pi-tc
        w.append((d*EquatorialRadius,tc/deg2rad,nombre))
      w.sort()
      txt=u"%s (%s)\n" %(ts,last_TS)
      for i in w :
        txt+="%.0f %0.f %s\n" %i
      del w
      txt+=u"%s" %fix[8]
      text_principal.set(txt)
      text_principal.set_pos(0)
  elif tab_visible==3 : # SAVER
    if tab_visible_old!=tab_visible :
      text_principal.clear()

  if tab_visible!=tab_visible_old :
    tab_visible_old=tab_visible


appuifw.app.title=old_title

print "%s: Terminando ejecucion" %time.ctime()[4:]

